osgManipulator::SpherePlaneProjector Class Reference

`#include <Projector>`

Inheritance diagram for osgManipulator::SpherePlaneProjector:

## Public Member Functions

| SpherePlaneProjector ()
| SpherePlaneProjector (osg::Sphere *sphere)
virtual bool | project (const PointerInfo &pi, osg::Vec3d &projectedPoint) const
bool | isProjectionOnSphere () const
osg::Quat | getRotation (const osg::Vec3d &p1, bool p1OnSphere, const osg::Vec3d &p2, bool p2OnSphere, float radialFactor=0.0f) const
Public Member Functions inherited from osgManipulator::SphereProjector
| SphereProjector ()
| SphereProjector (osg::Sphere *sphere)
void | setSphere (osg::Sphere *sphere)
const osg::Sphere * | getSphere () const
bool | isPointInFront (const PointerInfo &pi, const osg::Matrix &localToWorld) const
void | setFront (bool front)
Public Member Functions inherited from osgManipulator::Projector
| Projector ()
void | setLocalToWorld (const osg::Matrix &localToWorld)
const osg::Matrix & | getLocalToWorld () const
const osg::Matrix & | getWorldToLocal () const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~SpherePlaneProjector ()
Protected Member Functions inherited from osgManipulator::SphereProjector
virtual | ~SphereProjector ()
Protected Member Functions inherited from osgManipulator::Projector
virtual | ~Projector ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::Plane | _plane
bool | _onSphere
Protected Attributes inherited from osgManipulator::SphereProjector
osg::ref_ptr< osg::Sphere > | _sphere
bool | _front
Protected Attributes inherited from osgManipulator::Projector
osg::Matrix | _localToWorld
osg::Matrix | _worldToLocal
bool | _worldToLocalDirty
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

SpherePlaneProjector projects points onto a sphere, failing which it project onto a plane oriented to the viewing direction.

## Constructor & Destructor Documentation

## SpherePlaneProjector() [1/2]

osgManipulator::SpherePlaneProjector::SpherePlaneProjector | ( |  | ) |

## SpherePlaneProjector() [2/2]

osgManipulator::SpherePlaneProjector::SpherePlaneProjector | ( | osg::Sphere * | sphere | ) |

## ~SpherePlaneProjector()

virtual osgManipulator::SpherePlaneProjector::~SpherePlaneProjector | ( |  | ) |

protected virtual

## Member Function Documentation

## getRotation()

osg::Quat osgManipulator::SpherePlaneProjector::getRotation | ( | const osg::Vec3d & | p1,
|  | bool | p1OnSphere,
|  | const osg::Vec3d & | p2,
|  | bool | p2OnSphere,
|  | float | radialFactor = 0.0f ) const

## isProjectionOnSphere()

bool osgManipulator::SpherePlaneProjector::isProjectionOnSphere | ( |  | ) | const

inline

Returns true if the previous projection was on the sphere and false if the projection was on the plane.

References _onSphere.

## project()

virtual bool osgManipulator::SpherePlaneProjector::project | ( | const PointerInfo & | pi,
|  | osg::Vec3d & | projectedPoint ) const

virtual

Calculates the object coordinates (projectedPoint) of a window coordinate (pointToProject) when projected onto the given sphere. Returns true on successful projection.

Reimplemented from osgManipulator::SphereProjector.

## Member Data Documentation

## _onSphere

bool osgManipulator::SpherePlaneProjector::_onSphere

mutable protected

Referenced by isProjectionOnSphere().

## _plane

osg::Plane osgManipulator::SpherePlaneProjector::_plane

mutable protected

The documentation for this class was generated from the following file:

- Projector